import 'package:arctium_msg/arctium_msg.dart';
import 'package:flutter/material.dart';

void main() => runApp(MyApp());

class MyApp extends StatelessWidget {
  @override
  Widget build(BuildContext context) => MaterialApp(
        home: CounterScreen(),
      );
}

class IncrementMsg extends Msg<int> {
  IncrementMsg(int amount) : super(update: (current) => current + amount);
}

class DecrementMsg extends Msg<int> {
  DecrementMsg(int amount) : super(update: (current) => current - amount);
}

class CounterScreen extends StatelessWidget {
  @override
  Widget build(BuildContext context) => StoreInjector<int>(
        store: () => StoreA(initialModel: 0),
        builder: (_, store) => Scaffold(
          appBar: AppBar(
            title: Text("Arctium Msg example"),
          ),
          body: Center(
            child: CounterBody(),
          ),
        ),
      );
}

class CounterBody extends StatelessWidget {
  @override
  Widget build(BuildContext context) => Column(
        mainAxisAlignment: MainAxisAlignment.center,
        children: [
          Binder<int>(
            (model) => Text("Current value: $model"),
          ),
          OutlinedButton(
            onPressed: () => send<int>(IncrementMsg(2)),
            child: Text("Increment"),
          ),
          OutlinedButton(
            onPressed: () => send<int>(DecrementMsg(1)),
            child: Text("Decrement"),
          ),
        ],
      );
}
